
local addonName,addonData = ...

local actionBarFrame = CreateFrame("Frame","XUI_ActionBar_Frame",UIParent,"SecureHandlerStateTemplate,SecureHandlerAttributeTemplate,SecureHandlerShowHideTemplate")
local eventFrame = CreateFrame("Frame","XUI_ActionBar_Events")

local function CheckEvents(self,event,...)
	local args = { ... }
		
	if ( event == "ADDON_LOADED" ) then
		if ( args[1] == addonName ) then
			actionBarFrame:SetPoint("CENTER",UIParent,"CENTER",0,0)
			actionBarFrame:SetMovable(true)
			actionBarFrame:SetHeight(1)
			actionBarFrame:SetWidth(1)
			actionBarFrame:EnableMouse(true)
			actionBarFrame:RegisterForDrag("RightButton")
			if ( not actionBarFrame:IsUserPlaced() ) then 
				actionBarFrame:SetPoint("CENTER",UIParent,"CENTER",0,0) 
			end
			actionBarFrame:SetScript("OnDragStart",function(self)
				self:StartMoving()
			end)
			actionBarFrame:SetScript("OnDragStop",function(self)
				self:StopMovingOrSizing()
				self:SetUserPlaced(true)
				self:SetClampedToScreen(true)
			end)

			actionBarFrame:SetAttribute( "XUI_ActionType","ACTIONBUTTON" )
			
			-- As a page on the Main Action Bar
			--actionBarFrame:SetAttribute( "actionpage", 1 );

			-- As a standalone Action Bar

			-- The below action page is used in instances like Drak'tharon Keep
			--actionBarFrame:SetAttribute( "actionpage", GetTempShapeshiftBarIndex() );		

			-- The below action page is used in little games like at the fayre
			--actionBarFrame:SetAttribute( "actionpage",GetOverrideBarIndex());

			-- The below action page is used on the farm 
			actionBarFrame:SetAttribute( "actionpage",GetVehicleBarIndex());

			
			actionBarFrame.Buttons = { }
			local lastButton = nil

			hooksecurefunc( "ActionButton_UpdateHotkeys", function( self, actionButtonType )
	           --[[
				--print(self:GetName(),actionButtonType)
				local id
			    if ( not actionButtonType ) then
			        actionButtonType = "ACTIONBUTTON";
					id = self:GetID();
				else
					if ( actionButtonType == "MULTICASTACTIONBUTTON" ) then
						id = self.buttonIndex;
					else
						id = self:GetID();
					end
			    end
	            local actionName = id;
		        local key1, key2 = GetBindingKey( actionName );
	            local btnName    = self:GetName();

	            --print(actionName,key1,key2,btnName)
	            
	 	        if key1 then 
			        SetBinding( key1, "CLICK "..btnName..":LeftButton" );
		        end
		        if key2 then 
			        SetBinding( key2, "CLICK "..btnName..":LeftButton" );
		        end	        
		        --SaveBindings(1)    
		        _G[self:GetName().."HotKey"]:Show()
		        --]]
			end)

			for i = 1,12 do
				actionBarFrame.Buttons[i] = CreateFrame("CheckButton","$parent_Button_"..i,actionBarFrame,"SecureActionButtonTemplate,ActionBarButtonTemplate")
				actionBarFrame.Buttons[i]:SetScale(0.75)
				actionBarFrame.Buttons[i]:SetID(i)
				actionBarFrame.Buttons[i].flashing = 0;
				actionBarFrame.Buttons[i].flashtime = 0;
				actionBarFrame.Buttons[i]:SetAttribute("showgrid", 1);
				actionBarFrame.Buttons[i]:SetAttribute("type", "action");
				actionBarFrame.Buttons[i]:SetAttribute("checkselfcast", true);
				actionBarFrame.Buttons[i]:SetAttribute("checkfocuscast", true);
				actionBarFrame.Buttons[i]:SetAttribute("useparent-unit", true);
				actionBarFrame.Buttons[i]:SetAttribute("useparent-actionpage", true);
				actionBarFrame.Buttons[i]:SetAttribute("action", i );
				actionBarFrame.Buttons[i]:RegisterForDrag("LeftButton");
				actionBarFrame.Buttons[i]:RegisterForClicks("AnyUp");
				actionBarFrame.Buttons[i]:Show()
				if ( lastButton ) then
					actionBarFrame.Buttons[i]:SetPoint("TOPLEFT",lastButton,"TOPRIGHT",1,0)
				else
					actionBarFrame.Buttons[i]:SetPoint("TOPLEFT",actionBarFrame,"TOPLEFT",5,-5)
				end
				actionBarFrame:SetAttribute( "addchild", actionBarFrame.Buttons[i] );
				lastButton = actionBarFrame.Buttons[i]
				ActionButton_UpdateAction(lastButton);

			end
			actionBarFrame:SetHeight(lastButton:GetHeight() + 5)
			actionBarFrame:SetWidth(lastButton:GetWidth() * 12)
			
			-- As a standalone Action Bar
			RegisterStateDriver( actionBarFrame, "visibility", "[petbattle] hide; show" );
			--RegisterStateDriver( actionBarFrame, "visibility", "[petbattle] hide; [shapeshift] show" );
			--RegisterStateDriver( actionBarFrame, "visibility", "[petbattle] hide; [overridebar] show" );
			--RegisterStateDriver( actionBarFrame, "visibility", "[petbattle] hide; [vehicleui] show");
			--RegisterStateDriver( actionBarFrame, "visibility", "[petbattle] hide; [possessbar,@vehicle,exists] show");
			
			-- As a page on the Main Action Bar
			--RegisterStateDriver( actionBarFrame, "visibility", "[petbattle] hide; show" );

			actionBarFrame:Execute(
				[[
					ChildList     = newtable( self:GetChildren() );
					ActionButtons = newtable();
					actionType    = self:GetAttribute( "XUI_ActionType" );
								
					for i, child in ipairs( ChildList ) do
						ActionButtons[i] = child;
					end
				]]
			);

		    actionBarFrame:SetAttribute( 
				"_onstate-page", 
				[[
				
					self:SetAttribute( "actionpage", tonumber( value ) );
					
					for i, button in ipairs( ActionButtons ) do
						button:SetAttribute( "touch", nil )					
					end							
				]]
			);        

			actionBarFrame:SetAttribute("_onattributechanged",		
				[[


					-- If the bar is hidden by the state driver
					if ( name == "statehidden" ) then
						if ( value == true ) then
						end
					end

					-- If it automatically changes the page I guess
					if ( name == "state-page" or name == "actionpage" ) then
						for i,button in pairs(ActionButtons) do
							button:SetAttribute( "touch", nil )	
							button:SetAttribute( "actionpage", value)
						end
					end
				]]
			);

			actionBarFrame:SetFrameRef("ref",actionBarFrame)

			-- As a page on the Main Action Bar
			--RegisterStateDriver(actionBarFrame,"page",nil)
			--RegisterStateDriver(actionBarFrame, "page", string.format("[vehicleui] %d; [shapeshift] %d; [overridebar] %d; [bar:2] 2; [bar:3] 3; [bar:4] 4; [bar:5] 5; [bar:6] 6; [bonusbar:1] 7; [bonusbar:2] 8; [bonusbar:3] 9; [bonusbar:4] 10; [bonusbar:5] 11;1",GetVehicleBarIndex(),GetTempShapeshiftBarIndex(),GetOverrideBarIndex()) );
				
			--actionBarFrame:Show()
		end

	else

		if ( event == "ACTIONBAR_SLOT_CHANGED" ) then
			local slot,other = ...
			local type, id, subType, spellID = GetActionInfo(slot)
			local hasAction =  HasAction(slot)
			local texture = GetActionTexture(slot)
			if ( id ~= 0 and id ~= nil ) then
				local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(id)
				if ( hasAction ) then
					print(slot,id,name, icon,texture)
				else
					print(slot,id,name, icon,texture)
				end
			end
		else
			print(event,...)
		end

	end
	
end

eventFrame:RegisterEvent("ADDON_LOADED")
eventFrame:RegisterEvent("ACTIONBAR_PAGE_CHANGED");
eventFrame:RegisterEvent("UPDATE_VEHICLE_ACTIONBAR");
eventFrame:RegisterEvent("UPDATE_POSSESS_BAR");
eventFrame:RegisterEvent("ACTIONBAR_SLOT_CHANGED");

eventFrame:SetScript("OnEvent",CheckEvents)
